.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib
include shell32.inc
includelib shell32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

;**********************************************************************************************************

.data
AppName     db "Get Icons!",0

pNames      dd OFFSET f1,OFFSET f2,OFFSET f3,OFFSET f4,OFFSET f5,OFFSET f6,OFFSET f7,OFFSET f8,OFFSET f9
            dd OFFSET f11,OFFSET f12,OFFSET f13,OFFSET f14,0
f1          db "some.ini",0
f2          db "pe.exe",0
f3          db "a.dll",0
f4          db "test.asm",0
f5          db "text.txt",0
f6          db "something.html",0
f7          db "please.hlp",0
f8          db "amazing.pdf",0
f9          db "random.jpg",0
f10         db "noextension",0
f11         db "coo.mp3",0
f12         db "tiny.zip",0
f13         db "wicked.xml",0
f14         db "unknown.name",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
icox        DWORD       ?
icoy        DWORD       ?
shfi        SHFILEINFO <?>
hSysIml     HANDLE      ?       ;handle to the system's image list
nIcons      DWORD       ?       ;number of icons in our list
pIndxs      dd 16 dup (?)       ;list indexes for our wanted icons

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    push edi
    lea edi,[wc]
    assume edi:ptr WNDCLASSEX
    mov [edi].cbSize,SIZEOF wc
    mov [edi].style,CS_HREDRAW or CS_VREDRAW
    mov [edi].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [edi].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [edi].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [edi].hCursor,eax
    mov [edi].hbrBackground,COLOR_WINDOW+1
    mov [edi].lpszClassName,OFFSET AppName
    xor eax,eax
    mov [edi].cbClsExtra,eax
    mov [edi].cbWndExtra,eax
    mov [edi].lpszMenuName,eax
    mov [edi].hIconSm,eax
    invoke RegisterClassEx, edi
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea edi,[msg]
        assume edi:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, edi,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, edi
            invoke DispatchMessage, edi
        .ENDW
        mov eax,[edi].wParam
    .ENDIF
    assume edi:nothing
    pop edi
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL hDC:HDC
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        push esi
        push edi
        push ebx
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax
        mov esi,OFFSET pIndxs
        xor edi,edi
        xor ebx,ebx
      @@:
        mov eax,[esi+4*ebx]
        invoke ImageList_Draw, hSysIml,eax,hDC,edi,0,ILD_NORMAL
        add ebx,1
        add edi,icox
        cmp ebx,nIcons
        jl @B
        invoke EndPaint, hwnd,ADDR ps
        pop ebx
        pop edi
        pop esi
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        push ebx
        push edi
        push esi
        xor ebx,ebx
        mov edi,OFFSET pIndxs
        mov esi,OFFSET pNames

        ;use first one to get handle to system's image list, and its icon sizes
        mov eax,[esi]
        invoke SHGetFileInfo, eax,FILE_ATTRIBUTE_NORMAL,ADDR shfi,SIZEOF shfi,SHGFI_SYSICONINDEX+SHGFI_SMALLICON+SHGFI_USEFILEATTRIBUTES
        mov hSysIml,eax
        invoke ImageList_GetIconSize, eax,ADDR icox,ADDR icoy
        mov ecx,[shfi].iIcon
        mov [edi+4*ebx],ecx
      @@:
        add esi,4
        add ebx,1
        mov eax,[esi]
        test eax,eax
        jz @done
        invoke SHGetFileInfo, eax,FILE_ATTRIBUTE_NORMAL,ADDR shfi,SIZEOF shfi,SHGFI_SYSICONINDEX+SHGFI_SMALLICON+SHGFI_USEFILEATTRIBUTES
        mov ecx,[shfi].iIcon
        mov [edi+4*ebx],ecx
        jmp @B
      @done:
        mov nIcons,ebx
        pop esi
        pop edi
        pop ebx
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
